(use-modules ((gnu packages bash) #:select (bash))
             (guix build-system)
             (guix packages)
             (guix store)
             (guix utils)
             (ice-9 match))

(define gash
  (load (string-append (current-source-directory) "/../../guix.scm")))

(define gash-with-links
  (package
    (inherit gash)
    (arguments
     (substitute-keyword-arguments (package-arguments gash)
       ((#:phases phases '%standard-phases)
        `(modify-phases ,phases
           (add-after 'install 'link-bash
             (lambda* (#:key outputs #:allow-other-keys)
               (let ((out (assoc-ref outputs "out")))
                 (symlink (string-append out "/bin/gash")
                          (string-append out "/bin/sh"))
                 (symlink (string-append out "/bin/gash")
                          (string-append out "/bin/bash")))))))))))

(define bash-without-bash
  (let ((bash-bag (package->bag bash)))
    (bag
      (inherit bash-bag)
      (build-inputs
       `(("bash" ,gash-with-links)
         ,@(filter (match-lambda
                     ((name . _)
                      (not (member name '("bash")))))
                   (bag-build-inputs bash-bag)))))))

(bag->derivation (open-connection) bash-without-bash)
